package crawler;

import java.util.List;

import storers.Service;

/**
 * Main class used when accessing parser data. All calls to all parsers should go through this class
 *
 */
public class ParserInterface {
	
	private BookingComParser bcp = null;
	private TripAdvisorParser tap = null;

	public ParserInterface() {
		this.bcp = new BookingComParser();
		this.tap = new TripAdvisorParser();
	}
	
	public List<Service> search(String term, String source) {
		if(source.equals("booking.com")) {
			return bcp.search(term);
		} else if(source.equals("tripadvisor")) {
			return tap.crawl(new String[] {term, "hotels"});
		}
		return null;
	}
	
	
	public void startParserInterface(String source, String location) {
		ParserInterface pi = new ParserInterface();
		pi.search(location, source);
	}
}
