package gatherer;

import java.util.List;

import storers.Review;
import storers.Service;

/**
 * Class that calculates different statistic on the dataset. Everything from number of words and number of reviews.
 *
 */
public class Statistics {
	
	public Statistics(){}
	
	int totalNumWords(Service service){
		List<Review> reviews = service.getReviews();
		String textTotal = "";
		int numOfWords = 0;
		
		for (int i = 0; i < reviews.size(); i++){
			textTotal = "";
			textTotal += reviews.get(i).getComment() + " ";
			textTotal += reviews.get(i).getCommentBad() + " ";
			textTotal += reviews.get(i).getCommentGood() + " ";
			numOfWords += textTotal.split("\\s+").length;
		}
		return numOfWords;
	}
	
	int totalNumWords(List<Service> service){
		int numOfWords = 0;
		for (int i = 0; i<service.size(); i++){
			numOfWords += totalNumWords(service.get(i));
			
		}
		return numOfWords;
	}
	
	int averageNumWordsReview(List<Service> service){
		return totalNumWords(service)/totalNumReviews(service);
	}
	
	int totalNumCharacters(Service service){
		List<Review> reviews = service.getReviews();
		String textTotal = "";
		int numOfCharacters = 0;
		
		for (int i = 0; i < reviews.size(); i++){
			numOfCharacters = 0;
			textTotal += reviews.get(i).getComment() + " ";
			textTotal += reviews.get(i).getCommentBad() + " ";
			textTotal += reviews.get(i).getCommentGood() + " ";
			
			numOfCharacters += textTotal.length();
		}
		return numOfCharacters;
	}
	
	int totalNumCharacters(List<Service> service){
		int numOfCharacters = 0;
		for (int i = 0; i<service.size(); i++){
			numOfCharacters += totalNumCharacters(service.get(i));
			
		}
		return numOfCharacters;
	}
	
	int totalNumReviews(Service service){
		return service.getReviews().size();
	}
	
	int totalNumReviews(List<Service> service){
		int numOfReviews = 0;
		
		for (int i = 0; i < service.size(); i++){
			numOfReviews += totalNumReviews(service.get(i));
		}

		return numOfReviews;
	}
	
	double totalStarsScore(Service service){
		return service.getStars();
	}
	
	double totalStarsScore(List<Service> service){
		double totalStarsScore = 0.0;
		for (int i = 0; i<service.size(); i++){
			totalStarsScore += totalStarsScore(service.get(i));
		}
		return totalStarsScore;
	}
	
	double averageStarsScore(List<Service> service){
		return totalStarsScore(service)/service.size();
	}
	
	double totalReviewScore(Service service){
		List<Review> reviews = service.getReviews();
		double totalScore = 0.0;
		
		for (int i = 0; i<reviews.size(); i++){
			totalScore += reviews.get(i).getScore();
		}
		return totalScore;
	}
	
	double totalReviewScore(List<Service> service){
		double totalScore = 0.0;
		
		for (int i = 0; i<service.size(); i++){
			totalScore += totalReviewScore(service.get(i));
		}
		return totalScore;
	}
	
	double averageReviewScore(List<Service> service){
		return totalReviewScore(service)/totalNumReviews(service);
	}
	
	double averageReviewScore(Service service){
		return totalReviewScore(service)/totalNumReviews(service);
	}
}
