package processing;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import storers.SentiWord;

/**
 * Class that process all the SentiWordNet calculations.
 *
 */
public class SentiWordNet {
	
	private HashMap<String, SentiWord> sentiWords;
	
	public SentiWordNet(){
		sentiWords = new HashMap<String, SentiWord>();
	}
	
	/*
	 * Add all the words from SentiWordNet to memory.
	 */
	public void addSentiWords(){
		try {
			BufferedReader in = new BufferedReader(new FileReader(new File("SentiWordNet_3.0.0_20120206.txt")));
			String line = "";
			String[] info;
			while (( line = in.readLine()) != null){
				if (line.charAt(0) == '#'){
					continue;
				}
				info = line.split("\\s");
				if (info[2].equals("")){
					System.out.println(info[1] + info[4]);
				}
				SentiWord sw = new SentiWord(info[1], info[4], info[0],Double.parseDouble(info[2]), Double.parseDouble(info[3]));
				sentiWords.put(sw.getId()+sw.getWordType(), sw);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}

	public HashMap<String, SentiWord> getSentiWords() {
		return sentiWords;
	}
	
	public static void main(String[] args){
		SentiWordNet swn = new SentiWordNet();
		swn.addSentiWords();
		HashMap<String, SentiWord> map = swn.getSentiWords();
		for (Map.Entry<String, SentiWord> entry : map.entrySet()){
			System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue().getId() + entry.getValue().getWord());
		}
	}
}
