package storers;

import java.util.HashMap;

/**
 * Class that contains information about each hotels. Everything from name, score, latitude, longitude and so on. 
 * Mainly used in regards to burst detection, since we did not need all the reviews information to calculate the average scores. 
 *
 */

public class HotelScore {
	private String name;
	private String address;
	private double latitude;
	private double longitude;
	private double totalScore;
	private double totalActualScore;
	private int totalReviews;
	private HashMap<Integer, Double> averageMonthlyScore;
	private HashMap<Integer, Double> averageActualScore;
	private HashMap<Integer, Double> changeMonthlyScore;
	private HashMap<Integer, Double> changeActualScore;
	private HashMap<Integer, Integer> numberMonthlyReviews;
	
	public HotelScore(String name, String address, double latitude, double longitude) {
		this.setName(name);
		this.setAddress(address);
		this.setLatitude(latitude);
		this.setLongitude(longitude);
		this.setTotalScore(0.0);
		setAverageMonthlyScore(new HashMap<Integer, Double>());
		setAverageActualScore(new HashMap<Integer, Double>());
		setChangeMonthlyScore(new HashMap<Integer, Double>());
		setChangeActualScore(new HashMap<Integer, Double>());
		setNumberMonthlyReviews(new HashMap<Integer, Integer>());
	}

	public double getTotalScore() {
		return totalScore;
	}

	public void setTotalScore(double totalScore) {
		this.totalScore = totalScore;
	}

	public HashMap<Integer, Double> getAverageMonthlyScore() {
		return averageMonthlyScore;
	}

	public void setAverageMonthlyScore(HashMap<Integer, Double> averageMonthlyScore) {
		this.averageMonthlyScore = averageMonthlyScore;
	}
	
	public void setAverageMonthlyScore(Integer value, Double score){
		this.averageMonthlyScore.put(value, score);
	}

	public int getTotalReviews() {
		return totalReviews;
	}

	public void setTotalReviews(int totalReviews) {
		this.totalReviews = totalReviews;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public HashMap<Integer, Double> getAverageActualScore() {
		return averageActualScore;
	}

	public void setAverageActualScore(HashMap<Integer, Double> averageActualScore) {
		this.averageActualScore = averageActualScore;
	}	
	
	public void setAverageActualScore(Integer value, Double score){
		this.averageActualScore.put(value, score);
	}

	public double getTotalActualScore() {
		return totalActualScore;
	}

	public void setTotalActualScore(double totalActualScore) {
		this.totalActualScore = totalActualScore;
	}

	public HashMap<Integer, Double> getChangeMonthlyScore() {
		return changeMonthlyScore;
	}

	public void setChangeMonthlyScore(HashMap<Integer, Double> changeMonthlyScore) {
		this.changeMonthlyScore = changeMonthlyScore;
	}
	
	public void setChangeMonthlyScore(Integer value, Double score){
		this.changeMonthlyScore.put(value, score);
	}

	public HashMap<Integer, Integer> getNumberMonthlyReviews() {
		return numberMonthlyReviews;
	}

	public void setNumberMonthlyReviews(HashMap<Integer, Integer> numberMonthlyReviews) {
		this.numberMonthlyReviews = numberMonthlyReviews;
	}
	
	public void setNumberMonthlyReviews(Integer value, Integer score){
		this.numberMonthlyReviews.put(value, score);
	}

	public HashMap<Integer, Double> getChangeActualScore() {
		return changeActualScore;
	}

	public void setChangeActualScore(Integer value, Double score) {
		this.changeActualScore.put(value, score);
	}
	
	public void setChangeActualScore(HashMap<Integer, Double> changeActualScore) {
		this.changeActualScore = changeActualScore;
	}
}
