package storers;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Abstract class for different services. So far Hotel and Restaurant have been made.
 *
 */
public abstract class Service {
	
	public abstract List<Review> getReviews();
	
	public abstract void setReviews(List<Review> reviews);
	
	public abstract void addReview(Review review);
	
	public abstract ServiceType getType();
	
	public abstract String getName();
	
	public abstract String getAddress();
	
	public abstract double getStars();
	
	public abstract String getLatLong();
	
	public abstract double getLatitude();
	
	public abstract double getLongitude();
	
	public abstract void setLatitude(double latitude);
	
	public abstract void setLongitude(double longitude);
	
	public abstract Map<String,String> getFacilities();

	public abstract void setFacilities(String facGeneral, String facActivities,
			String facServices, String facInternet, String facParking);

	public abstract void setFacilities(Map<String, String> facilities);
	
	public abstract void setTotalPosScore(double totalScore);
	
	public abstract double getTotalPosScore();
	
	public abstract void setTotalNegScore(double totalScore);
	
	public abstract double getTotalNegScore();
	
	public abstract void setTotalNumberFeatures(int totalNumberFeatures);
	
	public abstract int getTotalNumberFeatures();
	
	public abstract void setFeaturePosScores(double[] featureScores);
	
	public abstract double[] getFeaturePosScores();
	
	public abstract void setFeatureNegScores(double[] featureScores);
	
	public abstract double[] getFeatureNegScores();
	
	public abstract void setTotalNumbers(int[] totalNumbers);
	
	public abstract int[] getTotalNumbers();
	
	public abstract void setSentences(ArrayList<Sentence> sentences);
	
	public abstract ArrayList<Sentence> getSentences();
}
